#include <msp/fs/path.h>
#include <msp/fs/utils.h>
#include "builder.h"
#include "virtualtarget.h"

using namespace std;
using namespace Msp;

VirtualTarget::VirtualTarget(Builder &b, const string &n):
	Target(b, n)
{ }

void VirtualTarget::check_rebuild()
{
	// Virtual targets are only rebuilt if their dependencies need rebuilding.
	for(Dependencies::iterator i=depends.begin(); (i!=depends.end() && !needs_rebuild()); ++i)
		if((*i)->needs_rebuild())
			mark_rebuild((*i)->get_name()+" needs rebuilding");
}

Task *VirtualTarget::build()
{
	state = UPTODATE;
	return 0;
}
